<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: SDIO function driver API</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>SDIO function driver API</h1>The SDIO function driver API is used to implement drivers for SDIO card functions.  
<a href="#_details">More...</a><table border=0 cellpadding=0 cellspacing=0>
<tr><td></td></tr>
<tr><td colspan=2><br><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>struct &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__card__io__ops.html">sdio_card_io_ops</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>struct &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__cmd.html">sdio_cmd</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>struct &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__dev.html">sdio_dev</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>struct &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html">sdio_func_driver</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>struct &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__id__table.html">sdio_id_table</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>union &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="unionsdio__response.html">sdio_response</a></td></tr>

<tr><td colspan=2><br><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga25">SDD_CMD_FLAG_RESP_NONE</a>&nbsp;&nbsp;&nbsp;0x00</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga26">SDD_CMD_FLAG_RESP_R1</a>&nbsp;&nbsp;&nbsp;0x01</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga27">SDD_CMD_FLAG_RESP_R1B</a>&nbsp;&nbsp;&nbsp;0x02</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga28">SDD_CMD_FLAG_RESP_R2</a>&nbsp;&nbsp;&nbsp;0x03</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga29">SDD_CMD_FLAG_RESP_R3</a>&nbsp;&nbsp;&nbsp;0x04</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga30">SDD_CMD_FLAG_RESP_R4</a>&nbsp;&nbsp;&nbsp;0x05</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga31">SDD_CMD_FLAG_RESP_R5</a>&nbsp;&nbsp;&nbsp;0x06</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga32">SDD_CMD_FLAG_RESP_R5B</a>&nbsp;&nbsp;&nbsp;0x07</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga33">SDD_CMD_FLAG_RESP_R6</a>&nbsp;&nbsp;&nbsp;0x08</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga34">SDD_CMD_FLAG_RESP_MASK</a>&nbsp;&nbsp;&nbsp;0xff</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top><a class="anchor" name="ga35" doxytag="fdriver::SDD_CMD_FLAG_RAW" ></a>
#define&nbsp;</td><td class="memItemRight" valign=bottom><b>SDD_CMD_FLAG_RAW</b>&nbsp;&nbsp;&nbsp;0x0100</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga36">SDD_CMD_FLAG_READ</a>&nbsp;&nbsp;&nbsp;0x0200</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga37">SDD_CMD_FLAG_CSPI</a>&nbsp;&nbsp;&nbsp;0x0400</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>#define&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga38">SDD_CMD_FLAG_ABORT</a>&nbsp;&nbsp;&nbsp;0x0800</td></tr>

<tr><td colspan=2><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>typedef int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga0">sdio_card_io_read8_t</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, uint8_t *data)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>typedef int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga1">sdio_card_io_write8_t</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, uint8_t data)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>typedef int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga2">sdio_card_io_read_t</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, uint8_t *data, size_t len)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>typedef int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga3">sdio_card_io_write_t</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, const uint8_t *data, size_t len)</td></tr>

<tr><td colspan=2><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>enum &nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga39">sdio_cmd_status</a> { <br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a24">SDD_CMD_OK</a> =  0x00, 
<br>
&nbsp;&nbsp;<b>SDD_CMD_ERR_CMD</b> =  0x01, 
<br>
&nbsp;&nbsp;<b>SDD_CMD_ERR_DAT</b> =  0x02, 
<br>
&nbsp;&nbsp;<b>SDD_CMD_ERR_CRC</b> =  0x10, 
<br>
&nbsp;&nbsp;<b>SDD_CMD_ERR_TIMEOUT</b> =  0x20, 
<br>
&nbsp;&nbsp;<b>SDD_CMD_ERR_OTHER</b> =  0x40, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a30">SDD_CMD_ERR_CMD_CRC</a> =  SDD_CMD_ERR_CMD | SDD_CMD_ERR_CRC, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a31">SDD_CMD_ERR_CMD_TIMEOUT</a> =  SDD_CMD_ERR_CMD | SDD_CMD_ERR_TIMEOUT, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a32">SDD_CMD_ERR_CMD_OTHER</a> =  SDD_CMD_ERR_CMD | SDD_CMD_ERR_OTHER, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a33">SDD_CMD_ERR_DAT_CRC</a> =  SDD_CMD_ERR_DAT | SDD_CMD_ERR_CRC, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a34">SDD_CMD_ERR_DAT_TIMEOUT</a> =  SDD_CMD_ERR_DAT | SDD_CMD_ERR_TIMEOUT, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a35">SDD_CMD_ERR_DAT_OTHER</a> =  SDD_CMD_ERR_DAT | SDD_CMD_ERR_OTHER, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a36">SDD_CMD_ERR_NO_CARD</a> =  0x04, 
<br>
&nbsp;&nbsp;<a class="el" href="group__fdriver.html#gga39a37">SDD_CMD_IN_PROGRESS</a> =  0xff
<br>
 }</td></tr>

<tr><td colspan=2><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga4">sdio_hard_reset</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga5">sdio_cis_get_tuple</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint8_t tuple, void *buf, size_t len)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga6">sdio_start_cmd</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, struct <a class="el" href="structsdio__cmd.html">sdio_cmd</a> *cmd)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga7">sdio_driver_register</a> (struct <a class="el" href="structsdio__func__driver.html">sdio_func_driver</a> *fdriver)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga8">sdio_driver_unregister</a> (struct <a class="el" href="structsdio__func__driver.html">sdio_func_driver</a> *fdriver)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga9">sdio_enable_function</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga10">sdio_disable_function</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga11">sdio_set_block_size</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int blksz)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga12">sdio_idle_function</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga13">sdio_set_max_bus_freq</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int max_freq)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga14">sdio_set_bus_width</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int bus_width)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga15">sdio_enable_interrupt</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga16">sdio_disable_interrupt</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga17">sdio_read8</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, uint8_t *val)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga18">sdio_write8</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, uint8_t val)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga19">sdio_f0_read8</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, uint8_t *val)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga20">sdio_f0_write8</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, uint8_t val)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga21">sdio_read</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, void *data, size_t len)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga22">sdio_write</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, const void *data, size_t len)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga23">sdio_power_on</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__fdriver.html#ga24">sdio_power_off</a> (struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
The SDIO function driver API is used to implement drivers for SDIO card functions. 
<p>
Function drivers register with the SDIO driver core (sdio_register_driver()), listing which functions it supports and providing callback functions for card inserts, removes and interrupts.<p>
<dl compact><dt><b><a class="anchor" name="card_io_ops"></a> Card I/O operations:</b></dt><dd></dd></dl>
<ul>
<li><a class="el" href="group__fdriver.html#ga17">sdio_read8()</a></li><li><a class="el" href="group__fdriver.html#ga18">sdio_write8()</a></li><li><a class="el" href="group__fdriver.html#ga19">sdio_f0_read8()</a></li><li><a class="el" href="group__fdriver.html#ga20">sdio_f0_write8()</a></li><li><a class="el" href="group__fdriver.html#ga21">sdio_read()</a></li><li><a class="el" href="group__fdriver.html#ga22">sdio_write()</a> </li></ul>
<hr><h2>Define Documentation</h2>
<a class="anchor" name="ga38" doxytag="sdio_api.h::SDD_CMD_FLAG_ABORT" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_ABORT&nbsp;&nbsp;&nbsp;0x0800
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Data transfer abort command.     </td>
  </tr>
</table>
<a class="anchor" name="ga37" doxytag="sdio_api.h::SDD_CMD_FLAG_CSPI" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_CSPI&nbsp;&nbsp;&nbsp;0x0400
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
CSPI transfer, not SDIO or SDIO-SPI.     </td>
  </tr>
</table>
<a class="anchor" name="ga36" doxytag="sdio_api.h::SDD_CMD_FLAG_READ" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_READ&nbsp;&nbsp;&nbsp;0x0200
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Data transfer is a read, not a write.     </td>
  </tr>
</table>
<a class="anchor" name="ga34" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_MASK" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_MASK&nbsp;&nbsp;&nbsp;0xff
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Mask for response type.     </td>
  </tr>
</table>
<a class="anchor" name="ga25" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_NONE" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_NONE&nbsp;&nbsp;&nbsp;0x00
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
No response.     </td>
  </tr>
</table>
<a class="anchor" name="ga26" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R1" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R1&nbsp;&nbsp;&nbsp;0x01
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R1 response.     </td>
  </tr>
</table>
<a class="anchor" name="ga27" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R1B" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R1B&nbsp;&nbsp;&nbsp;0x02
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R1b response.     </td>
  </tr>
</table>
<a class="anchor" name="ga28" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R2" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R2&nbsp;&nbsp;&nbsp;0x03
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R2 response.     </td>
  </tr>
</table>
<a class="anchor" name="ga29" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R3" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R3&nbsp;&nbsp;&nbsp;0x04
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R3 response.     </td>
  </tr>
</table>
<a class="anchor" name="ga30" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R4" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R4&nbsp;&nbsp;&nbsp;0x05
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R4 response.     </td>
  </tr>
</table>
<a class="anchor" name="ga31" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R5" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R5&nbsp;&nbsp;&nbsp;0x06
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R5 response.     </td>
  </tr>
</table>
<a class="anchor" name="ga32" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R5B" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R5B&nbsp;&nbsp;&nbsp;0x07
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R5b response.     </td>
  </tr>
</table>
<a class="anchor" name="ga33" doxytag="sdio_api.h::SDD_CMD_FLAG_RESP_R6" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> #define SDD_CMD_FLAG_RESP_R6&nbsp;&nbsp;&nbsp;0x08
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
R6 response.     </td>
  </tr>
</table>
<hr><h2>Typedef Documentation</h2>
<a class="anchor" name="ga0" doxytag="sdio_api.h::sdio_card_io_read8_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef int(* <a class="el" href="group__fdriver.html#ga0">sdio_card_io_read8_t</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, uint8_t *data)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read an 8 bit wide card register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>sdio device to read from. </td></tr>
    <tr><td valign=top><em>function</em>&nbsp;</td><td>card function number. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>returns the value read.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on an error: -EIO if a low-level transport error occurred (e.g., CRC error), -ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga2" doxytag="sdio_api.h::sdio_card_io_read_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef int(* <a class="el" href="group__fdriver.html#ga2">sdio_card_io_read_t</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, uint8_t *data, size_t len)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read a buffer from an 8 bit wide card register/FIFO.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>sdio device to read from. </td></tr>
    <tr><td valign=top><em>function</em>&nbsp;</td><td>card function number. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer to store the data read. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of the buffer.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on an error: -EIO if a low-level transport error occurred (e.g., CRC error), -ETIMEDOUT if no response or data was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga1" doxytag="sdio_api.h::sdio_card_io_write8_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef int(* <a class="el" href="group__fdriver.html#ga1">sdio_card_io_write8_t</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, uint8_t data)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Writes an 8 bit wide register on a card.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>sdio device to write to. </td></tr>
    <tr><td valign=top><em>function</em>&nbsp;</td><td>card function number. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>value to write.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on an error: -EIO if a low-level transport error occurred (e.g., CRC error), -ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga3" doxytag="sdio_api.h::sdio_card_io_write_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef int(* <a class="el" href="group__fdriver.html#ga3">sdio_card_io_write_t</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev, int function, uint32_t addr, const uint8_t *data, size_t len)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Writes a buffer to an 8 bit wide card register/FIFO.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>sdio device to write to. </td></tr>
    <tr><td valign=top><em>function</em>&nbsp;</td><td>card function number. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer of data to write. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of the buffer.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on an error: -EIO if a low-level transport error occurred (e.g., CRC error), -ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<hr><h2>Enumeration Type Documentation</h2>
<a class="anchor" name="ga39" doxytag="sdio_api.h::sdio_cmd_status" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> enum <a class="el" href="group__fdriver.html#ga39">sdio_cmd_status</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
SDIO command status. <dl compact><dt><b>Enumeration values: </b></dt><dd>
<table border=0 cellspacing=2 cellpadding=0>
<tr><td valign=top><em><a class="anchor" name="gga39a24" doxytag="SDD_CMD_OK" ></a>SDD_CMD_OK</em>&nbsp;</td><td>
Command successful. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a30" doxytag="SDD_CMD_ERR_CMD_CRC" ></a>SDD_CMD_ERR_CMD_CRC</em>&nbsp;</td><td>
Response CRC error. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a31" doxytag="SDD_CMD_ERR_CMD_TIMEOUT" ></a>SDD_CMD_ERR_CMD_TIMEOUT</em>&nbsp;</td><td>
Response time out. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a32" doxytag="SDD_CMD_ERR_CMD_OTHER" ></a>SDD_CMD_ERR_CMD_OTHER</em>&nbsp;</td><td>
Other response error. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a33" doxytag="SDD_CMD_ERR_DAT_CRC" ></a>SDD_CMD_ERR_DAT_CRC</em>&nbsp;</td><td>
Data CRC error. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a34" doxytag="SDD_CMD_ERR_DAT_TIMEOUT" ></a>SDD_CMD_ERR_DAT_TIMEOUT</em>&nbsp;</td><td>
Data receive time out. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a35" doxytag="SDD_CMD_ERR_DAT_OTHER" ></a>SDD_CMD_ERR_DAT_OTHER</em>&nbsp;</td><td>
Other data error. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a36" doxytag="SDD_CMD_ERR_NO_CARD" ></a>SDD_CMD_ERR_NO_CARD</em>&nbsp;</td><td>
No card present. </td></tr>
<tr><td valign=top><em><a class="anchor" name="gga39a37" doxytag="SDD_CMD_IN_PROGRESS" ></a>SDD_CMD_IN_PROGRESS</em>&nbsp;</td><td>
Command still in progress. </td></tr>
</table>
</dl>
    </td>
  </tr>
</table>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="ga5" doxytag="sdio_cis.c::sdio_cis_get_tuple" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_cis_get_tuple </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t&nbsp;</td>
          <td class="mdname" nowrap> <em>tuple</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>buf</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read a CIS tuple.<p>
Copies the specified function's CIS tuple into a buffer. The tuple ID and link pointer are not copied.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>function to read CIS from. </td></tr>
    <tr><td valign=top><em>tuple</em>&nbsp;</td><td>ID of tuple to find. </td></tr>
    <tr><td valign=top><em>buf</em>&nbsp;</td><td>destination buffer for tuple data. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of <em>buf</em>.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error: -ENXIO - no such tuple found, -EINVAL - buffer is shorter than the tuple, -EIO,-ETIMEDOUT - I/O error while reading from card. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga10" doxytag="sdio_func.c::sdio_disable_function" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_disable_function </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Disable the function.<p>
The function's I/O Enable bit is cleared.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device to disable.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error: -EIO or -ETIMEDOUT - a register access failed.</dd></dl>
<p>
<dl compact><dt><b><a class="el" href="bug.html#_bug000002">Bug:</a></b></dt><dd>To permit a disable/enable sequence to be used as a per-function reset, disabling a function should wait for I/O Ready to be cleared. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga16" doxytag="sdio_int.c::sdio_disable_interrupt" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_disable_interrupt </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Prevent this SDIO device from receiving card interrupt signals.<p>
This only affects the routing of card interrupts from the core.<p>
Function drivers should ensure they clear any pending interrupts before calling this.<p>
Callable from: any context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device to disable interrupt routing for.</td></tr>
  </table>
</dl>
<dl compact><dt><b>See also:</b></dt><dd><a class="el" href="group__fdriver.html#ga55">sdio_enable_interrupt()</a>. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga7" doxytag="sdio_core.c::sdio_driver_register" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_driver_register </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__func__driver.html">sdio_func_driver</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdriver</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Register a function driver with the core.<p>
If any inserted cards that have functions that match <em>fdriver's</em> list of supported functions then <em>fdriver's</em> probe() function will be called for those functions.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdriver</em>&nbsp;</td><td>the function driver to register.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error: -ENOMEM - maximum number of function drivers are already registered. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga8" doxytag="sdio_core.c::sdio_driver_unregister" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_driver_unregister </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__func__driver.html">sdio_func_driver</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdriver</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Unregister a function driver from the core.<p>
<em>fdriver's</em> remove() will be called for any SDIO devices currently attached to the driver.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdriver</em>&nbsp;</td><td>the function driver to unregister. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga9" doxytag="sdio_func.c::sdio_enable_function" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_enable_function </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Enable the function.<p>
The function's I/O Enable bit is set and I/O Ready is polled until it is set.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device to enable.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error: -ETIMEDOUT - time out waiting for I/O Ready to be set, -EIO or -ETIMEDOUT - a register access failed. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga15" doxytag="sdio_int.c::sdio_enable_interrupt" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_enable_interrupt </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Allow this SDIO device to receive card interrupt signals.<p>
This only affects the routing of card interrupts from the core.<p>
Callable from: any context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device to enable interrupt routing for.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Note:</b></dt><dd>The core always sets the I/O Enable bits for all functions, so interrupts sources on the card should be enabled and disabled in a function specific manner by the function driver. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga19" doxytag="sdio_io.c::sdio_f0_read8" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_f0_read8 </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>val</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read an 8 bit wide function 0 register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>an SDIO function of the card. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>val</em>&nbsp;</td><td>returns the value read.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-EIO if a low-level transport error occurred (e.g., CRC error), <p>
-ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga20" doxytag="sdio_io.c::sdio_f0_write8" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_f0_write8 </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t&nbsp;</td>
          <td class="mdname" nowrap> <em>val</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Write an 8 bit wide function 0 register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>an SDIO function of the card. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>val</em>&nbsp;</td><td>value to write.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-EIO if a low-level transport error occurred (e.g., CRC error), <p>
-ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga4" doxytag="sdio_card.c::sdio_hard_reset" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_hard_reset </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Perform a hard reset of the card (if the slot is capable) and reinitialize the card.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>an SDIO device of the card.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 if a hard reset was performed and the card successfully reinitialized. <p>
1 if the slot is not capable of hard resets. <p>
-ve if the reinitialization failed. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga12" doxytag="sdio_func.c::sdio_idle_function" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_idle_function </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set the function as idle.<p>
When all functions are idle the SD bus will be idled.<p>
Functions are set as active (non-idle) when a command is started.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device to set as idle.</td></tr>
  </table>
</dl>
<dl compact><dt><b>See also:</b></dt><dd>slot_driver::idle_bus. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga24" doxytag="sdio_pm.c::sdio_power_off" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_power_off </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Allow the card to be powered off.<p>
If no other function is requesting power, the card is powered off. The driver must call <a class="el" href="group__fdriver.html#ga53">sdio_power_on()</a> before performing any more I/O to the card.<p>
Interrupts are disabled by calling <a class="el" href="group__fdriver.html#ga56">sdio_disable_interrupt()</a> as the DAT1/INT line may no longer be pulled high when power is removed.<p>
This is called by the core after calling a function driver's remove() method.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device not requiring power. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga23" doxytag="sdio_pm.c::sdio_power_on" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_power_on </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>fdev</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Request power to the card.<p>
If the card is not powered, apply power and re-initialize the card. No per-function state of the card is restored and the driver should re-enable the function and perform any other function specific initialization.<p>
This is called by the core before calling a function driver's probe() method.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device requesting power. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga21" doxytag="sdio_io.c::sdio_read" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_read </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read a buffer from an 8 bit wide card register/FIFO.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>SDIO function to read from. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer to store the data read. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of the buffer.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-EIO if a low-level transport error occurred (e.g., CRC error). <p>
-ETIMEDOUT if no response or data was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga17" doxytag="sdio_io.c::sdio_read8" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_read8 </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>val</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read an 8 bit wide register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>SDIO function to read from. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>val</em>&nbsp;</td><td>returns the value read.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-EIO if a low-level transport error occurred (e.g., CRC error), <p>
-ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga11" doxytag="sdio_func.c::sdio_set_block_size" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_set_block_size </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>blksz</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set a function's block size.<p>
The default block size is the largest supported by both the function and the host, with a maximum of 512 to ensure that arbitrarily sized data transfers use the optimal (least) number of commands.<p>
A driver may call this to override the default block size set by the core. This can be used to set a block size greater than the maximum that reported by the card; it is the driver's responsibility to ensure it uses a value that the card supports.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device. </td></tr>
    <tr><td valign=top><em>blksz</em>&nbsp;</td><td>new block size or 0 to use the default.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error: -EIO or -ETIMEDOUT - a register access failed. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga14" doxytag="sdio_func.c::sdio_set_bus_width" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_set_bus_width </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>bus_width</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set the SDIO bus to 1 bit or 4 bit mode.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device. </td></tr>
    <tr><td valign=top><em>bus_width</em>&nbsp;</td><td>the bus width (1 or 4).</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success (or if the slot is in SPI mode). <p>
-EINVAL if the slot doesn't support the requested mode. <p>
-EIO, -ETIMEDOUT if an I/O error occured when writing the mode to the card. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga13" doxytag="sdio_func.c::sdio_set_max_bus_freq" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_set_max_bus_freq </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>max_freq</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Limit the bus frequency supported by a function.<p>
The bus frequency used will be the minimum of:<ul>
<li>the speed reported by the card,</li><li>the maximum the slot can support,</li><li>the value set by this function for any of the card's functions.</li></ul>
<p>
If the frequency to be used is high speed (&gt; 25 MHz), high speed mode will be enabled on the card.<p>
Callable from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device. </td></tr>
    <tr><td valign=top><em>max_freq</em>&nbsp;</td><td>maximum frequency in Hz, or 0 for the maximum reported by the card. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga6" doxytag="sdio_cmd.c::sdio_start_cmd" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_start_cmd </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>struct <a class="el" href="structsdio__cmd.html">sdio_cmd</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>cmd</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Submit an SDIO command to a device.<p>
The command will be queued and executed when the card becomes available.<p>
Each SDIO device has a queue with one entry. Therefore, only one command per SDIO device may be submitted at a time.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the SDIO device submitting the command. </td></tr>
    <tr><td valign=top><em>cmd</em>&nbsp;</td><td>the command to submit.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd><em>0</em> if the command was queued. <p>
<em>-EAGAIN</em> if the command queue is full. <p>
<em>-EINVAL</em> if the data transfer is invalid (unsupported buffer alignment or the length is not a valid byte or block mode transfer).</dd></dl>
<dl compact><dt><b>See also:</b></dt><dd><a class="el" href="structsdio__dev.html#o7">sdio_dev::io</a> </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga22" doxytag="sdio_io.c::sdio_write" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_write </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>const void *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Writes a buffer to an 8 bit wide card register/FIFO.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>SDIO function to write to. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer of data to write. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of the buffer.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-EIO if a low-level transport error occurred (e.g., CRC error). <p>
-ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga18" doxytag="sdio_io.c::sdio_write8" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_write8 </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>fdev</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t&nbsp;</td>
          <td class="mdname" nowrap> <em>val</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Write an 8 bit wide register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>SDIO function to write to. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>val</em>&nbsp;</td><td>value to write.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-EIO if a low-level transport error occurred (e.g., CRC error), <p>
-ETIMEDOUT if no response was received. </dd></dl>
    </td>
  </tr>
</table>
<hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
